# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from . import utilities, tables

class License(pulumi.CustomResource):
    edition_key: pulumi.Output[str]
    """
    The product edition of the license key.
    """
    labels: pulumi.Output[dict]
    """
    A map of key/value pairs to be attached as labels (tags) to the license key.
    """
    license_key: pulumi.Output[str]
    """
    The license key to add.
    """
    name: pulumi.Output[str]
    """
    The display name for the license.
    """
    total: pulumi.Output[int]
    """
    Total number of units (example: CPUs) contained in the license.
    """
    used: pulumi.Output[int]
    """
    The number of units (example: CPUs) assigned to this license.
    """
    def __init__(__self__, __name__, __opts__=None, labels=None, license_key=None):
        """
        Provides a VMware vSphere license resource. This can be used to add and remove license keys.
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[dict] labels: A map of key/value pairs to be attached as labels (tags) to the license key.
        :param pulumi.Input[str] license_key: The license key to add.
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['labels'] = labels

        if not license_key:
            raise TypeError('Missing required property license_key')
        __props__['license_key'] = license_key

        __props__['edition_key'] = None
        __props__['name'] = None
        __props__['total'] = None
        __props__['used'] = None

        super(License, __self__).__init__(
            'vsphere:index/license:License',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

