# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import pulumi
import pulumi.runtime
from . import utilities, tables

class VirtualMachine(pulumi.CustomResource):
    alternate_guest_name: pulumi.Output[str]
    """
    The guest name for the operating system
    when `guest_id` is `other` or `other-64`.
    """
    annotation: pulumi.Output[str]
    """
    A user-provided description of the virtual machine.
    The default is no annotation.
    """
    boot_delay: pulumi.Output[int]
    """
    The number of milliseconds to wait before starting
    the boot sequence. The default is no delay.
    """
    boot_retry_delay: pulumi.Output[int]
    """
    The number of milliseconds to wait before
    retrying the boot sequence. This only valid if `boot_retry_enabled` is true.
    Default: `10000` (10 seconds).
    """
    boot_retry_enabled: pulumi.Output[bool]
    """
    If set to true, a virtual machine that
    fails to boot will try again after the delay defined in `boot_retry_delay`.
    Default: `false`.
    """
    cdrom: pulumi.Output[dict]
    """
    A specification for a CDROM device on this virtual
    machine. See CDROM options below.
    """
    change_version: pulumi.Output[str]
    """
    A unique identifier for a given version of the last
    configuration applied, such the timestamp of the last update to the
    configuration.
    """
    clone: pulumi.Output[dict]
    """
    When specified, the VM will be created as a clone of a
    specified template. Optional customization options can be submitted as well.
    See creating a virtual machine from a
    template for more details.
    """
    cpu_hot_add_enabled: pulumi.Output[bool]
    """
    Allow CPUs to be added to this virtual
    machine while it is running.
    """
    cpu_hot_remove_enabled: pulumi.Output[bool]
    """
    Allow CPUs to be removed to this
    virtual machine while it is running.
    """
    cpu_limit: pulumi.Output[int]
    """
    The maximum amount of CPU (in MHz) that this virtual
    machine can consume, regardless of available resources. The default is no
    limit.
    """
    cpu_performance_counters_enabled: pulumi.Output[bool]
    """
    Enable CPU performance
    counters on this virtual machine. Default: `false`.
    """
    cpu_reservation: pulumi.Output[int]
    """
    The amount of CPU (in MHz) that this virtual
    machine is guaranteed. The default is no reservation.
    """
    cpu_share_count: pulumi.Output[int]
    """
    The number of CPU shares allocated to the
    virtual machine when the `cpu_share_level` is `custom`.
    """
    cpu_share_level: pulumi.Output[str]
    """
    The allocation level for CPU resources. Can be
    one of `high`, `low`, `normal`, or `custom`. Default: `custom`.
    """
    custom_attributes: pulumi.Output[dict]
    """
    Map of custom attribute ids to attribute
    value strings to set for virtual machine. See
    [here][docs-setting-custom-attributes] for a reference on how to set values
    for custom attributes.
    """
    datastore_cluster_id: pulumi.Output[str]
    """
    The [managed object reference
    ID][docs-about-morefs] of the datastore cluster ID to use. This setting
    applies to entire virtual machine and implies that you wish to use Storage
    DRS with this virtual machine. See the section on virtual machine
    migration for details on changing this value.
    """
    datastore_id: pulumi.Output[str]
    """
    The datastore ID that the ISO is located in.
    Requried for using a datastore ISO. Conflicts with `client_device`.
    """
    default_ip_address: pulumi.Output[str]
    """
    The IP address selected by Terraform to be used with
    any [provisioners][tf-docs-provisioners] configured on this resource.
    Whenever possible, this is the first IPv4 address that is reachable through
    the default gateway configured on the machine, then the first reachable IPv6
    address, and then the first general discovered address if neither exist. If
    VMware tools is not running on the virtual machine, or if the VM is powered
    off, this value will be blank.
    """
    disks: pulumi.Output[list]
    """
    A specification for a virtual disk device on this virtual
    machine. See disk options below.
    """
    efi_secure_boot_enabled: pulumi.Output[bool]
    """
    When the `firmware` type is set to is
    `efi`, this enables EFI secure boot. Default: `false`.
    """
    enable_disk_uuid: pulumi.Output[bool]
    """
    Expose the UUIDs of attached virtual disks to
    the virtual machine, allowing access to them in the guest. Default: `false`.
    """
    enable_logging: pulumi.Output[bool]
    """
    Enable logging of virtual machine events to a
    log file stored in the virtual machine directory. Default: `false`.
    """
    ept_rvi_mode: pulumi.Output[str]
    """
    The EPT/RVI (hardware memory virtualization)
    setting for this virtual machine. Can be one of `automatic`, `on`, or `off`.
    Default: `automatic`.
    """
    extra_config: pulumi.Output[dict]
    """
    Extra configuration data for this virtual
    machine. Can be used to supply advanced parameters not normally in
    configuration, such as data for cloud-config (under the guestinfo namespace).
    """
    firmware: pulumi.Output[str]
    """
    The firmware interface to use on the virtual machine.
    Can be one of `bios` or `EFI`. Default: `bios`.
    """
    folder: pulumi.Output[str]
    """
    The path to the folder to put this virtual machine in,
    relative to the datacenter that the resource pool is in.
    """
    force_power_off: pulumi.Output[bool]
    """
    If a guest shutdown failed or timed out while
    updating or destroying (see
    `shutdown_wait_timeout`), force the power-off of
    the virtual machine. Default: `true`.
    """
    guest_id: pulumi.Output[str]
    """
    The guest ID for the operating system type. For a
    full list of possible values, see [here][vmware-docs-guest-ids]. Default: `other-64`.
    """
    guest_ip_addresses: pulumi.Output[list]
    """
    The current list of IP addresses on this machine,
    including the value of `default_ip_address`. If VMware tools is not running
    on the virtual machine, or if the VM is powered off, this list will be empty.
    * `moid`: The [managed object reference ID][docs-about-morefs] of the created
    virtual machine.
    """
    host_system_id: pulumi.Output[str]
    """
    An optional [managed object reference
    ID][docs-about-morefs] of a host to put this virtual machine on. See the
    section on virtual machine migration for
    details on changing this value. If a `host_system_id` is not supplied,
    vSphere will select a host in the resource pool to place the virtual machine,
    according to any defaults or DRS policies in place.
    """
    hv_mode: pulumi.Output[str]
    """
    The (non-nested) hardware virtualization setting for
    this virtual machine. Can be one of `hvAuto`, `hvOn`, or `hvOff`. Default:
    `hvAuto`.
    """
    imported: pulumi.Output[bool]
    """
    This is flagged if the virtual machine has been imported, or the
    state has been migrated from a previous version of the resource. It
    influences the behavior of the first post-import apply operation. See the
    section on importing below.
    """
    latency_sensitivity: pulumi.Output[str]
    """
    Controls the scheduling delay of the
    virtual machine. Use a higher sensitivity for applications that require lower
    latency, such as VOIP, media player applications, or applications that
    require frequent access to mouse or keyboard devices. Can be one of `low`,
    `normal`, `medium`, or `high`.
    """
    memory: pulumi.Output[int]
    """
    The size of the virtual machine's memory, in MB.
    Default: `1024` (1 GB).
    """
    memory_hot_add_enabled: pulumi.Output[bool]
    """
    Allow memory to be added to this
    virtual machine while it is running.
    """
    memory_limit: pulumi.Output[int]
    """
    The maximum amount of memory (in MB) that this
    virtual machine can consume, regardless of available resources. The default
    is no limit.
    """
    memory_reservation: pulumi.Output[int]
    """
    The amount of memory (in MB) that this
    virtual machine is guaranteed. The default is no reservation.
    """
    memory_share_count: pulumi.Output[int]
    """
    The number of memory shares allocated to
    the virtual machine when the `memory_share_level` is `custom`.
    """
    memory_share_level: pulumi.Output[str]
    """
    The allocation level for memory resources.
    Can be one of `high`, `low`, `normal`, or `custom`. Default: `custom`.
    """
    migrate_wait_timeout: pulumi.Output[int]
    """
    The amount of time, in minutes, to wait
    for a virtual machine migration to complete before failing. Default: 10
    minutes. Also see the section on virtual machine
    migration.
    """
    moid: pulumi.Output[str]
    name: pulumi.Output[str]
    """
    An alias for both `label` and `path`, the latter when
    using `attach`. Required if not using `label`.
    """
    nested_hv_enabled: pulumi.Output[bool]
    """
    Enable nested hardware virtualization on
    this virtual machine, facilitating nested virtualization in the guest.
    Default: `false`.
    """
    network_interfaces: pulumi.Output[list]
    """
    A specification for a virtual NIC on this
    virtual machine. See network interface options
    below.
    """
    num_cores_per_socket: pulumi.Output[int]
    """
    The number of cores to distribute among
    the CPUs in this virtual machine. If specified, the value supplied to
    `num_cpus` must be evenly divisible by this value. Default: `1`.
    """
    num_cpus: pulumi.Output[int]
    """
    The number of virtual processors to assign to this
    virtual machine. Default: `1`.
    """
    reboot_required: pulumi.Output[bool]
    """
    Value internal to Terraform used to determine if a
    configuration set change requires a reboot. This value is only useful during
    an update process and gets reset on refresh.
    """
    resource_pool_id: pulumi.Output[str]
    """
    The [managed object reference
    ID][docs-about-morefs] of the resource pool to put this virtual machine in.
    See the section on virtual machine migration
    for details on changing this value.
    """
    run_tools_scripts_after_power_on: pulumi.Output[bool]
    """
    Enable the execution of
    post-power-on scripts when VMware tools is installed. Default: `true`.
    """
    run_tools_scripts_after_resume: pulumi.Output[bool]
    """
    Enable the execution of
    post-resume scripts when VMware tools is installed. Default: `true`.
    """
    run_tools_scripts_before_guest_reboot: pulumi.Output[bool]
    """
    Enable the execution of
    pre-reboot scripts when VMware tools is installed. Default: `false`.
    """
    run_tools_scripts_before_guest_shutdown: pulumi.Output[bool]
    """
    Enable the execution
    of pre-shutdown scripts when VMware tools is installed. Default: `true`.
    """
    run_tools_scripts_before_guest_standby: pulumi.Output[bool]
    """
    Enable the execution of
    pre-standby scripts when VMware tools is installed. Default: `true`.
    """
    scsi_bus_sharing: pulumi.Output[str]
    """
    Mode for sharing the SCSI bus. The modes are
    physicalSharing, virtualSharing, and noSharing. Default: `noSharing`.
    """
    scsi_controller_count: pulumi.Output[int]
    """
    The number of SCSI controllers that
    Terraform manages on this virtual machine. This directly affects the amount
    of disks you can add to the virtual machine and the maximum disk unit number.
    Note that lowering this value does not remove controllers. Default: `1`.
    """
    scsi_type: pulumi.Output[str]
    """
    The type of SCSI bus this virtual machine will have.
    Can be one of lsilogic (LSI Logic Parallel), lsilogic-sas (LSI Logic SAS) or
    pvscsi (VMware Paravirtual). Defualt: `pvscsi`.
    """
    shutdown_wait_timeout: pulumi.Output[int]
    """
    The amount of time, in minutes, to wait
    for a graceful guest shutdown when making necessary updates to the virtual
    machine. If `force_power_off` is set to true, the VM will be force powered-off
    after this timeout, otherwise an error is returned. Default: 3 minutes.
    """
    swap_placement_policy: pulumi.Output[str]
    """
    The swap file placement policy for this
    virtual machine. Can be one of `inherit`, `hostLocal`, or `vmDirectory`.
    Default: `inherit`.
    """
    sync_time_with_host: pulumi.Output[bool]
    """
    Enable guest clock synchronization with
    the host. Requires VMware tools to be installed. Default: `false`.
    """
    tags: pulumi.Output[list]
    """
    The IDs of any tags to attach to this resource. See
    [here][docs-applying-tags] for a reference on how to apply tags.
    """
    uuid: pulumi.Output[str]
    """
    The UUID of the virtual disk's VMDK file. This is used to track the
    virtual disk on the virtual machine.
    """
    vapp: pulumi.Output[dict]
    """
    Optional vApp configuration. The only sub-key available
    is `properties`, which is a key/value map of properties for virtual machines
    imported from OVF or OVA files. See Using vApp properties to supply OVF/OVA
    configuration for
    more details.
    """
    vapp_transports: pulumi.Output[list]
    """
    Computed value which is only valid for cloned virtual
    machines. A list of vApp transport methods supported by the source virtual
    machine or template.
    """
    vmware_tools_status: pulumi.Output[str]
    """
    The state of VMware tools in the guest. This will
    determine the proper course of action for some device operations.
    """
    vmx_path: pulumi.Output[str]
    """
    The path of the virtual machine's configuration file in the VM's
    datastore.
    """
    wait_for_guest_net_routable: pulumi.Output[bool]
    """
    Controls whether or not the guest
    network waiter waits for a routable address. When `false`, the waiter does
    not wait for a default gateway, nor are IP addresses checked against any
    discovered default gateways as part of its success criteria. Default: `true`.
    """
    wait_for_guest_net_timeout: pulumi.Output[int]
    """
    The amount of time, in minutes, to
    wait for an available IP address on this virtual machine. A value less than 1
    disables the waiter. Default: 5 minutes.
    """
    def __init__(__self__, __name__, __opts__=None, alternate_guest_name=None, annotation=None, boot_delay=None, boot_retry_delay=None, boot_retry_enabled=None, cdrom=None, clone=None, cpu_hot_add_enabled=None, cpu_hot_remove_enabled=None, cpu_limit=None, cpu_performance_counters_enabled=None, cpu_reservation=None, cpu_share_count=None, cpu_share_level=None, custom_attributes=None, datastore_cluster_id=None, datastore_id=None, disks=None, efi_secure_boot_enabled=None, enable_disk_uuid=None, enable_logging=None, ept_rvi_mode=None, extra_config=None, firmware=None, folder=None, force_power_off=None, guest_id=None, host_system_id=None, hv_mode=None, latency_sensitivity=None, memory=None, memory_hot_add_enabled=None, memory_limit=None, memory_reservation=None, memory_share_count=None, memory_share_level=None, migrate_wait_timeout=None, name=None, nested_hv_enabled=None, network_interfaces=None, num_cores_per_socket=None, num_cpus=None, resource_pool_id=None, run_tools_scripts_after_power_on=None, run_tools_scripts_after_resume=None, run_tools_scripts_before_guest_reboot=None, run_tools_scripts_before_guest_shutdown=None, run_tools_scripts_before_guest_standby=None, scsi_bus_sharing=None, scsi_controller_count=None, scsi_type=None, shutdown_wait_timeout=None, swap_placement_policy=None, sync_time_with_host=None, tags=None, vapp=None, wait_for_guest_net_routable=None, wait_for_guest_net_timeout=None):
        """
        The `vsphere_virtual_machine` resource can be used to manage the complex
        lifecycle of a virtual machine. It supports management of disk, network
        interface, and CDROM devices, creation from scratch or cloning from template,
        and migration through both host and storage vMotion.
        
        For more details on working with virtual machines in vSphere, see [this
        page][vmware-docs-vm-management].
        
        [vmware-docs-vm-management]: https://docs.vmware.com/en/VMware-vSphere/6.5/com.vmware.vsphere.vm_admin.doc/GUID-55238059-912E-411F-A0E9-A7A536972A91.html
        
        
        :param str __name__: The name of the resource.
        :param pulumi.ResourceOptions __opts__: Options for the resource.
        :param pulumi.Input[str] alternate_guest_name: The guest name for the operating system
               when `guest_id` is `other` or `other-64`.
        :param pulumi.Input[str] annotation: A user-provided description of the virtual machine.
               The default is no annotation.
        :param pulumi.Input[int] boot_delay: The number of milliseconds to wait before starting
               the boot sequence. The default is no delay.
        :param pulumi.Input[int] boot_retry_delay: The number of milliseconds to wait before
               retrying the boot sequence. This only valid if `boot_retry_enabled` is true.
               Default: `10000` (10 seconds).
        :param pulumi.Input[bool] boot_retry_enabled: If set to true, a virtual machine that
               fails to boot will try again after the delay defined in `boot_retry_delay`.
               Default: `false`.
        :param pulumi.Input[dict] cdrom: A specification for a CDROM device on this virtual
               machine. See CDROM options below.
        :param pulumi.Input[dict] clone: When specified, the VM will be created as a clone of a
               specified template. Optional customization options can be submitted as well.
               See creating a virtual machine from a
               template for more details.
        :param pulumi.Input[bool] cpu_hot_add_enabled: Allow CPUs to be added to this virtual
               machine while it is running.
        :param pulumi.Input[bool] cpu_hot_remove_enabled: Allow CPUs to be removed to this
               virtual machine while it is running.
        :param pulumi.Input[int] cpu_limit: The maximum amount of CPU (in MHz) that this virtual
               machine can consume, regardless of available resources. The default is no
               limit.
        :param pulumi.Input[bool] cpu_performance_counters_enabled: Enable CPU performance
               counters on this virtual machine. Default: `false`.
        :param pulumi.Input[int] cpu_reservation: The amount of CPU (in MHz) that this virtual
               machine is guaranteed. The default is no reservation.
        :param pulumi.Input[int] cpu_share_count: The number of CPU shares allocated to the
               virtual machine when the `cpu_share_level` is `custom`.
        :param pulumi.Input[str] cpu_share_level: The allocation level for CPU resources. Can be
               one of `high`, `low`, `normal`, or `custom`. Default: `custom`.
        :param pulumi.Input[dict] custom_attributes: Map of custom attribute ids to attribute
               value strings to set for virtual machine. See
               [here][docs-setting-custom-attributes] for a reference on how to set values
               for custom attributes.
        :param pulumi.Input[str] datastore_cluster_id: The [managed object reference
               ID][docs-about-morefs] of the datastore cluster ID to use. This setting
               applies to entire virtual machine and implies that you wish to use Storage
               DRS with this virtual machine. See the section on virtual machine
               migration for details on changing this value.
        :param pulumi.Input[str] datastore_id: The datastore ID that the ISO is located in.
               Requried for using a datastore ISO. Conflicts with `client_device`.
        :param pulumi.Input[list] disks: A specification for a virtual disk device on this virtual
               machine. See disk options below.
        :param pulumi.Input[bool] efi_secure_boot_enabled: When the `firmware` type is set to is
               `efi`, this enables EFI secure boot. Default: `false`.
        :param pulumi.Input[bool] enable_disk_uuid: Expose the UUIDs of attached virtual disks to
               the virtual machine, allowing access to them in the guest. Default: `false`.
        :param pulumi.Input[bool] enable_logging: Enable logging of virtual machine events to a
               log file stored in the virtual machine directory. Default: `false`.
        :param pulumi.Input[str] ept_rvi_mode: The EPT/RVI (hardware memory virtualization)
               setting for this virtual machine. Can be one of `automatic`, `on`, or `off`.
               Default: `automatic`.
        :param pulumi.Input[dict] extra_config: Extra configuration data for this virtual
               machine. Can be used to supply advanced parameters not normally in
               configuration, such as data for cloud-config (under the guestinfo namespace).
        :param pulumi.Input[str] firmware: The firmware interface to use on the virtual machine.
               Can be one of `bios` or `EFI`. Default: `bios`.
        :param pulumi.Input[str] folder: The path to the folder to put this virtual machine in,
               relative to the datacenter that the resource pool is in.
        :param pulumi.Input[bool] force_power_off: If a guest shutdown failed or timed out while
               updating or destroying (see
               `shutdown_wait_timeout`), force the power-off of
               the virtual machine. Default: `true`.
        :param pulumi.Input[str] guest_id: The guest ID for the operating system type. For a
               full list of possible values, see [here][vmware-docs-guest-ids]. Default: `other-64`.
        :param pulumi.Input[str] host_system_id: An optional [managed object reference
               ID][docs-about-morefs] of a host to put this virtual machine on. See the
               section on virtual machine migration for
               details on changing this value. If a `host_system_id` is not supplied,
               vSphere will select a host in the resource pool to place the virtual machine,
               according to any defaults or DRS policies in place.
        :param pulumi.Input[str] hv_mode: The (non-nested) hardware virtualization setting for
               this virtual machine. Can be one of `hvAuto`, `hvOn`, or `hvOff`. Default:
               `hvAuto`.
        :param pulumi.Input[str] latency_sensitivity: Controls the scheduling delay of the
               virtual machine. Use a higher sensitivity for applications that require lower
               latency, such as VOIP, media player applications, or applications that
               require frequent access to mouse or keyboard devices. Can be one of `low`,
               `normal`, `medium`, or `high`.
        :param pulumi.Input[int] memory: The size of the virtual machine's memory, in MB.
               Default: `1024` (1 GB).
        :param pulumi.Input[bool] memory_hot_add_enabled: Allow memory to be added to this
               virtual machine while it is running.
        :param pulumi.Input[int] memory_limit: The maximum amount of memory (in MB) that this
               virtual machine can consume, regardless of available resources. The default
               is no limit.
        :param pulumi.Input[int] memory_reservation: The amount of memory (in MB) that this
               virtual machine is guaranteed. The default is no reservation.
        :param pulumi.Input[int] memory_share_count: The number of memory shares allocated to
               the virtual machine when the `memory_share_level` is `custom`.
        :param pulumi.Input[str] memory_share_level: The allocation level for memory resources.
               Can be one of `high`, `low`, `normal`, or `custom`. Default: `custom`.
        :param pulumi.Input[int] migrate_wait_timeout: The amount of time, in minutes, to wait
               for a virtual machine migration to complete before failing. Default: 10
               minutes. Also see the section on virtual machine
               migration.
        :param pulumi.Input[str] name: An alias for both `label` and `path`, the latter when
               using `attach`. Required if not using `label`.
        :param pulumi.Input[bool] nested_hv_enabled: Enable nested hardware virtualization on
               this virtual machine, facilitating nested virtualization in the guest.
               Default: `false`.
        :param pulumi.Input[list] network_interfaces: A specification for a virtual NIC on this
               virtual machine. See network interface options
               below.
        :param pulumi.Input[int] num_cores_per_socket: The number of cores to distribute among
               the CPUs in this virtual machine. If specified, the value supplied to
               `num_cpus` must be evenly divisible by this value. Default: `1`.
        :param pulumi.Input[int] num_cpus: The number of virtual processors to assign to this
               virtual machine. Default: `1`.
        :param pulumi.Input[str] resource_pool_id: The [managed object reference
               ID][docs-about-morefs] of the resource pool to put this virtual machine in.
               See the section on virtual machine migration
               for details on changing this value.
        :param pulumi.Input[bool] run_tools_scripts_after_power_on: Enable the execution of
               post-power-on scripts when VMware tools is installed. Default: `true`.
        :param pulumi.Input[bool] run_tools_scripts_after_resume: Enable the execution of
               post-resume scripts when VMware tools is installed. Default: `true`.
        :param pulumi.Input[bool] run_tools_scripts_before_guest_reboot: Enable the execution of
               pre-reboot scripts when VMware tools is installed. Default: `false`.
        :param pulumi.Input[bool] run_tools_scripts_before_guest_shutdown: Enable the execution
               of pre-shutdown scripts when VMware tools is installed. Default: `true`.
        :param pulumi.Input[bool] run_tools_scripts_before_guest_standby: Enable the execution of
               pre-standby scripts when VMware tools is installed. Default: `true`.
        :param pulumi.Input[str] scsi_bus_sharing: Mode for sharing the SCSI bus. The modes are
               physicalSharing, virtualSharing, and noSharing. Default: `noSharing`.
        :param pulumi.Input[int] scsi_controller_count: The number of SCSI controllers that
               Terraform manages on this virtual machine. This directly affects the amount
               of disks you can add to the virtual machine and the maximum disk unit number.
               Note that lowering this value does not remove controllers. Default: `1`.
        :param pulumi.Input[str] scsi_type: The type of SCSI bus this virtual machine will have.
               Can be one of lsilogic (LSI Logic Parallel), lsilogic-sas (LSI Logic SAS) or
               pvscsi (VMware Paravirtual). Defualt: `pvscsi`.
        :param pulumi.Input[int] shutdown_wait_timeout: The amount of time, in minutes, to wait
               for a graceful guest shutdown when making necessary updates to the virtual
               machine. If `force_power_off` is set to true, the VM will be force powered-off
               after this timeout, otherwise an error is returned. Default: 3 minutes.
        :param pulumi.Input[str] swap_placement_policy: The swap file placement policy for this
               virtual machine. Can be one of `inherit`, `hostLocal`, or `vmDirectory`.
               Default: `inherit`.
        :param pulumi.Input[bool] sync_time_with_host: Enable guest clock synchronization with
               the host. Requires VMware tools to be installed. Default: `false`.
        :param pulumi.Input[list] tags: The IDs of any tags to attach to this resource. See
               [here][docs-applying-tags] for a reference on how to apply tags.
        :param pulumi.Input[dict] vapp: Optional vApp configuration. The only sub-key available
               is `properties`, which is a key/value map of properties for virtual machines
               imported from OVF or OVA files. See Using vApp properties to supply OVF/OVA
               configuration for
               more details.
        :param pulumi.Input[bool] wait_for_guest_net_routable: Controls whether or not the guest
               network waiter waits for a routable address. When `false`, the waiter does
               not wait for a default gateway, nor are IP addresses checked against any
               discovered default gateways as part of its success criteria. Default: `true`.
        :param pulumi.Input[int] wait_for_guest_net_timeout: The amount of time, in minutes, to
               wait for an available IP address on this virtual machine. A value less than 1
               disables the waiter. Default: 5 minutes.
        """
        if not __name__:
            raise TypeError('Missing resource name argument (for URN creation)')
        if not isinstance(__name__, str):
            raise TypeError('Expected resource name to be a string')
        if __opts__ and not isinstance(__opts__, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')

        __props__ = dict()

        __props__['alternate_guest_name'] = alternate_guest_name

        __props__['annotation'] = annotation

        __props__['boot_delay'] = boot_delay

        __props__['boot_retry_delay'] = boot_retry_delay

        __props__['boot_retry_enabled'] = boot_retry_enabled

        __props__['cdrom'] = cdrom

        __props__['clone'] = clone

        __props__['cpu_hot_add_enabled'] = cpu_hot_add_enabled

        __props__['cpu_hot_remove_enabled'] = cpu_hot_remove_enabled

        __props__['cpu_limit'] = cpu_limit

        __props__['cpu_performance_counters_enabled'] = cpu_performance_counters_enabled

        __props__['cpu_reservation'] = cpu_reservation

        __props__['cpu_share_count'] = cpu_share_count

        __props__['cpu_share_level'] = cpu_share_level

        __props__['custom_attributes'] = custom_attributes

        __props__['datastore_cluster_id'] = datastore_cluster_id

        __props__['datastore_id'] = datastore_id

        __props__['disks'] = disks

        __props__['efi_secure_boot_enabled'] = efi_secure_boot_enabled

        __props__['enable_disk_uuid'] = enable_disk_uuid

        __props__['enable_logging'] = enable_logging

        __props__['ept_rvi_mode'] = ept_rvi_mode

        __props__['extra_config'] = extra_config

        __props__['firmware'] = firmware

        __props__['folder'] = folder

        __props__['force_power_off'] = force_power_off

        __props__['guest_id'] = guest_id

        __props__['host_system_id'] = host_system_id

        __props__['hv_mode'] = hv_mode

        __props__['latency_sensitivity'] = latency_sensitivity

        __props__['memory'] = memory

        __props__['memory_hot_add_enabled'] = memory_hot_add_enabled

        __props__['memory_limit'] = memory_limit

        __props__['memory_reservation'] = memory_reservation

        __props__['memory_share_count'] = memory_share_count

        __props__['memory_share_level'] = memory_share_level

        __props__['migrate_wait_timeout'] = migrate_wait_timeout

        __props__['name'] = name

        __props__['nested_hv_enabled'] = nested_hv_enabled

        if not network_interfaces:
            raise TypeError('Missing required property network_interfaces')
        __props__['network_interfaces'] = network_interfaces

        __props__['num_cores_per_socket'] = num_cores_per_socket

        __props__['num_cpus'] = num_cpus

        if not resource_pool_id:
            raise TypeError('Missing required property resource_pool_id')
        __props__['resource_pool_id'] = resource_pool_id

        __props__['run_tools_scripts_after_power_on'] = run_tools_scripts_after_power_on

        __props__['run_tools_scripts_after_resume'] = run_tools_scripts_after_resume

        __props__['run_tools_scripts_before_guest_reboot'] = run_tools_scripts_before_guest_reboot

        __props__['run_tools_scripts_before_guest_shutdown'] = run_tools_scripts_before_guest_shutdown

        __props__['run_tools_scripts_before_guest_standby'] = run_tools_scripts_before_guest_standby

        __props__['scsi_bus_sharing'] = scsi_bus_sharing

        __props__['scsi_controller_count'] = scsi_controller_count

        __props__['scsi_type'] = scsi_type

        __props__['shutdown_wait_timeout'] = shutdown_wait_timeout

        __props__['swap_placement_policy'] = swap_placement_policy

        __props__['sync_time_with_host'] = sync_time_with_host

        __props__['tags'] = tags

        __props__['vapp'] = vapp

        __props__['wait_for_guest_net_routable'] = wait_for_guest_net_routable

        __props__['wait_for_guest_net_timeout'] = wait_for_guest_net_timeout

        __props__['change_version'] = None
        __props__['default_ip_address'] = None
        __props__['guest_ip_addresses'] = None
        __props__['imported'] = None
        __props__['moid'] = None
        __props__['reboot_required'] = None
        __props__['uuid'] = None
        __props__['vapp_transports'] = None
        __props__['vmware_tools_status'] = None
        __props__['vmx_path'] = None

        super(VirtualMachine, __self__).__init__(
            'vsphere:index/virtualMachine:VirtualMachine',
            __name__,
            __props__,
            __opts__)


    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

